/**
 * @since 1.0.0
 */
import type { RDSClientConfig } from "@aws-sdk/client-rds";
import { Effect, Layer } from "effect";
import type { RDSService } from "./RDSService.js";
/**
 * @since 1.0.0
 * @category rds service config
 */
export declare const withRDSServiceConfig: {
    (config: RDSService.Config): <A, E, R>(effect: Effect.Effect<A, E, R>) => Effect.Effect<A, E, R>;
    <A, E, R>(effect: Effect.Effect<A, E, R>, config: RDSService.Config): Effect.Effect<A, E, R>;
};
/**
 * @since 1.0.0
 * @category rds service config
 */
export declare const setRDSServiceConfig: (config: RDSService.Config) => Layer.Layer<never, never, never>;
/**
 * @since 1.0.0
 * @category adapters
 */
export declare const toRDSClientConfig: Effect.Effect<RDSClientConfig>;
//# sourceMappingURL=RDSServiceConfig.d.ts.map